﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace wpfWorkItemListViewer
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new WorkList();
        }
    }
    

    public class WorkList : INotifyPropertyChanged
    {
        public WorkList ()	
        {
            LoadData();
	    }

        private List<WorkListItem> _workListItems;
        public List<WorkListItem> WorkListItems 
        {
            get { return _workListItems; }
            set { 
                _workListItems = value; 
                RaisePropertyChanged("WorkListItems"); 
            } 
        }

        private void LoadData()
        {
            this.WorkListItems = new List<WorkListItem>();
            WorkListItem wli = new WorkListItem();
            wli.Items = new Dictionary<string, string>();
            wli.Items.Add("One", "1");
            wli.Items.Add("Two", "2");
            wli.Items.Add("Three", "3");
            this.WorkListItems.Add(wli);

            WorkListItem wli2 = new WorkListItem();
            wli2.Items = new Dictionary<string, string>();
            wli2.Items.Add("One", "11");
            wli2.Items.Add("Two", "22");
            wli2.Items.Add("Three", "33");
            this.WorkListItems.Add(wli2);


            WorkListItem wli3 = new WorkListItem();
            wli3.Items = new Dictionary<string, string>();
            wli3.Items.Add("One", "111");
            wli3.Items.Add("Two", "222");
            wli3.Items.Add("Three", "333");
            this.WorkListItems.Add(wli3);
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void RaisePropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    public class WorkListItem : INotifyPropertyChanged
    {
        private Dictionary<string, string> _items;
        public Dictionary<string,string> Items 
        {
            get { return _items; }
            set
            {
                _items = value;
                RaisePropertyChanged("Items");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void RaisePropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
